//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen 
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern double FastLimit   = 0.5;
extern double SlowLimit   = 0.05;
extern int    Price       = PRICE_MEDIAN;
extern int    PriceFilter = 1;
extern int    PriceFilterMode = MODE_EMA;

//
//
//
//
//

double mama[];
double fama[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,mama);
   SetIndexBuffer(1,fama);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double work[][14];
#define _price     0
#define _smooth    1
#define _detrender 2
#define _period    3
#define _phase     4
#define _Q1        5
#define _I1        6
#define _JI        7
#define _JQ        8
#define _Q2        9
#define _I2       10
#define _Re       11
#define _Im       12
#define _sa       13

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

int start()
{
   double rad2degree = 180.0/Pi;
   int    i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
            if (returnBars) { mama[0] = limit+1; return(0); }
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);              
                     mama[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLimit,SlowLimit,Price,PriceFilter,PriceFilterMode,0,y);
                     fama[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLimit,SlowLimit,Price,PriceFilter,PriceFilterMode,1,y);
               }
               return(0);
            }

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_price]     = iMA(NULL,0,PriceFilter,0,PriceFilterMode,Price,i);
      work[r][_smooth]    = (4.0*work[r][_price]+3.0*work[r-1][_price]+2.0*work[r-2][_price]+work[r-3][_price])/10.0;
      work[r][_detrender] = calcComp(r,_smooth);
      work[r][_Q1]        = calcComp(r,_detrender);
      work[r][_I1]        = work[r-3][_detrender];
      work[r][_JI]        = calcComp(r,_I1);
      work[r][_JQ]        = calcComp(r,_Q1);
      
      //
      //
      //
      //
      //
      
      work[r][_I2] = 0.2*(work[r][_I1]-work[r][_JQ])                                 + 0.8*work[r-1][_I2];
      work[r][_Q2] = 0.2*(work[r][_Q1]+work[r][_JI])                                 + 0.8*work[r-1][_Q2];
      work[r][_Re] = 0.2*(work[r][_I2]*work[r-1][_I2] + work[r][_Q2]*work[r-1][_Q2]) + 0.8*work[r-1][_Re];
      work[r][_Im] = 0.2*(work[r][_I2]*work[r-1][_Q2] - work[r][_Q2]*work[r-1][_I2]) + 0.8*work[r-1][_Im];
      
      if (work[r][_Re]!= 0 && work[r][_Im]!=0) 
          work[r][_period] = 360.0/(MathArctan(work[r][_Im]/work[r][_Re])*rad2degree);
          work[r][_period] = MathMin(work[r][_period],1.50*work[r-1][_period]);
          work[r][_period] = MathMax(work[r][_period],0.67*work[r-1][_period]);
          work[r][_period] = MathMin(MathMax(work[r][_period],6),50);
          work[r][_period] = 0.2*work[r][_period]+0.8*work[r-1][_period];
      
      //
      //
      //
      //
      //
      
      if( work[r][_I1] != 0) work[r][_phase] = MathArctan(work[r][_Q1]/work[r][_I1])*rad2degree;
                  double DeltaPhase = MathMax(work[r-1][_phase]-work[r][_phase],1);
                  double Alpha      = MathMax(MathMin(FastLimit/DeltaPhase,FastLimit),SlowLimit);
      work[r][_sa] = Alpha;
	
      //
      //
      //
      //
      //

      mama[i] =     work[r][_sa]*work[r][_price] + (1.0-    work[r][_sa])*mama[i+1];
      fama[i] = 0.5*work[r][_sa]*mama[i]         + (1.0-0.5*work[r][_sa])*fama[i+1];
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double calcComp(int r, int from)
{
   return((0.0962*work[r  ][from] + 
           0.5769*work[r-2][from] - 
           0.5769*work[r-4][from] - 
           0.0962*work[r-6][from]) * (0.075*work[r-1][_period] + 0.54));
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}